unit uRekDateiSuche;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ePfad: TEdit;
    lPfad: TLabel;
    bBearbeite: TButton;
    mListe: TMemo;
    procedure bBearbeiteClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bBearbeiteClick(Sender: TObject);

  procedure bearbeite(maske : string);
  const
    FileAttr = faReadOnly+faHidden+faArchive; // zustzlich zu normalen D.
  var
    FPfad,Fname : string;
    Search      : TSearchRec;
    FListe      : TStringList;
  begin
    FPfad := ExtractFilePath(maske);
    FName := ExtractFileName(maske);
    if FPfad[Length(FPfad)] <> '\' then FPfad := FPfad+'\';
    FListe := TStringList.Create;
    FListe.Clear;
    // Files suchen
    if FindFirst(maske,FileAttr,Search) = 0 then
      repeat
        FListe.Add(FPfad+Search.Name);
        mListe.Lines.Add(FPfad+Search.Name) // DEBUG
      until FindNext(Search) <> 0;
    // Liste bearbeiten
    FListe.Free;
    mListe.Lines.Add('  '); // DEBUG
    // Unterverzeichnisse bearbeiten
    if FindFirst(maske,faDirectory,Search) = 0 then
      repeat
        if ((Search.Attr and faDirectory) > 0) and
           (Search.Name <> '.') and
           (Search.Name <> '..')
        then
        begin
          mListe.Lines.Add(FPfad+Search.Name) // DEBUG
          bearbeite(FPfad+Search.Name+'\'+FName);
        end;
      until FindNext(Search) <> 0;
  end;

begin
  bearbeite('.\*.*');
end;

end.
