unit uRekDateiSuche;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    eMaske: TEdit;
    lMaske: TLabel;
    bBearbeite: TButton;
    mListe: TMemo;
    procedure bBearbeiteClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bBearbeiteClick(Sender: TObject);
var
  maske : string;
  
  function suffix(f : string) : string;
  var
    i : integer;
  begin
    i := Length(f);
    while (f[i] <> '.') and (i > 0) do dec(i);
    if i = 0 then // kein Punkt gefunden
      result := ''
    else
      result := copy(f,i,Length(f)-i+1);
  end;


  procedure bearbeite(maske : string);
  const
    FileAttr = faReadOnly+faHidden+faArchive; // zustzlich zu normalen D.
  var
    FPfad,Fname,Ftemp : string;
    Search            : TSearchRec;
    FListe            : TStringList;
    i,pos             : integer;
  begin
    FPfad := ExtractFilePath(maske);
    if FPfad = '' then FPfad := '.\';
    if FPfad[Length(FPfad)] <> '\' then FPfad := FPfad+'\';
    FName := ExtractFileName(maske);
    // Liste aufbauen
    FListe := TStringList.Create;
    // Files suchen
    if FindFirst(maske,FileAttr,Search) = 0 then
    repeat
      FListe.Add(FPfad+Search.Name);
      mListe.Lines.Add(FPfad+Search.Name) // DEBUG
    until FindNext(Search) <> 0;
    FindClose(Search);
    // Liste bearbeiten
    mListe.Lines.Add('  '); // DEBUG
    for i := 0 to Fliste.Count-1 do
    begin
      if suffix(FListe[i]) = '.exe' then
      begin
        mListe.Lines.Add(FListe[i]); // DEBUG
        Ftemp := copy(FListe[i],1,Length(FListe[i])-4);
        mListe.Lines.Add(Ftemp); // DEBUG
        Ftemp := Ftemp+'.dpr';
        mListe.Lines.Add(Ftemp); // DEBUG
        pos := FListe.IndexOf(Ftemp);
        mListe.Lines.Add(IntToStr(pos)); // DEBUG
        if pos > -1 then // anscheinend Delphi-Ordner
        begin
          // aktive und schreibgeschtzte Dateien werden nicht gelscht
          deleteFile(FListe[i]);
          // hier folgen weitere Aktivitten im Delphi-Ordner
        end;
        mListe.Lines.Add(IntToStr(pos)); // DEBUG
      end;
      if true then    // hier eventuell Schalter einbauen
      begin
        if suffix(FListe[i])[2]='~' then deleteFile(FListe[i]);
        if suffix(FListe[i])='.dcu' then deleteFile(FListe[i]);
        if suffix(FListe[i])='.cfg' then deleteFile(FListe[i]);
        if suffix(FListe[i])='.dof' then deleteFile(FListe[i]);
        if suffix(FListe[i])='.ddp' then deleteFile(FListe[i]);
      end;
    end;
    FListe.Free;
    mListe.Lines.Add('  '); // DEBUG

    // Unterverzeichnisse bearbeiten
    if FindFirst(maske,faDirectory,Search) = 0 then
    repeat
      if ((Search.Attr and faDirectory) > 0) and
          (Search.Name <> '.') and
          (Search.Name <> '..')
      then
      begin
        mListe.Lines.Add(FPfad+Search.Name); // DEBUG
        bearbeite(FPfad+Search.Name+'\'+FName);
      end;
    until FindNext(Search) <> 0;
    FindClose(Search);
  end;

begin
  maske := eMaske.text;

  bearbeite(maske);
end;

end.
